package edu.wpi.ejutr.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IViewActionDelegate;
import org.eclipse.jface.dialogs.IDialogSettings;

import edu.wpi.ebob.ObjBenchPlugin;
import edu.wpi.ejutr.wizards.RecordTestMethodWizard;

import edu.wpi.ejutr.ebob_observer.*;
import edu.wpi.ejutr.logger.*;

/**
 * The action physically present in context menus that initiates the recording
 * of a new test mthod.
 * 
 */
public class RecordNewTestMethod implements IObjectActionDelegate, IViewActionDelegate {

	private IWorkbenchPart targetPart;
	
	/**
	 * Constructor.
	 */
	public RecordNewTestMethod() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		Shell shell = new Shell();
		RecordTestMethodWizard newMethodWizard = new RecordTestMethodWizard();
		WizardDialog dialog = new WizardDialog(shell, newMethodWizard);
		if (dialog.open() == WizardDialog.OK) {
			// clear current log
			EBOBActionLogger eal = EBOBActionLogger.getInstance();
			eal.clearLog();
			
			// clear current targetFileInfo and store new info
			EJUTRTargetFileInfo targetInfo = EJUTRTargetFileInfo.getInstance();
			targetInfo.clear();
			targetInfo.setTestContainer(newMethodWizard.getConName());
			targetInfo.setTestFileName(newMethodWizard.getObjName()); 
			targetInfo.setTestMethodName(newMethodWizard.getMehtodName());
			
			// clear bench			
			ObjBenchPlugin objBenchPlugin = ObjBenchPlugin.getDefault();
			objBenchPlugin.getBench().removeAll();
			objBenchPlugin.getClassManager().disassociateProject();
			
			// attach listener
			EBOBListener eList = EBOBListener.getInstance();
			eList. attach(true);
			
			
		}
		
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
	}

	public void init(IViewPart view) {
		targetPart = view;
		
	}

}
