package edu.wpi.ejutr.wizards;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.*;
import org.eclipse.ui.*;

/**
 * The wizard for adding assertions into the EJUTR log.
 * @author Ben Mohlenhoff - bigben@wpi.edu
 */
public class AssertionWizard extends Wizard {

	private AssertionWizardPage page;
	private String methodType;
	private String methodCall;
	private String lhs;
	private String rhs;
	private String comp;
	private boolean exp;
	private boolean doAssert;
	
	public AssertionWizard(String retType, String methodCall) {
		super();
		methodType = retType;
		this.methodCall = methodCall;
	}
	
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		// TODO Auto-generated method stub
		
	}

	public void addPages() {
		page = new AssertionWizardPage(methodType, methodCall);
		addPage(page);
	}

	public boolean performFinish() {				
		lhs = page.getLHS();
		rhs = page.getRHS();
		comp = page.getComparison();
		exp = page.getExpectedResult();
		doAssert = page.getAssertStatus();
		
		return true;
	}

	public String getLHS() {
		return lhs;
	}
	
	public String getComparison() {
		return comp;
	}
	
	public String getRHS() {
		return rhs;
	}
	
	public boolean getExpectedResult() {
		return exp;
	}
	
	public boolean doAssert() {
		return doAssert;
	}
	
}
