package edu.wpi.ejutr.wizards;

import org.eclipse.core.resources.ICommand;
import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Status;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.jface.dialogs.IDialogSettings;
import org.eclipse.jface.dialogs.DialogSettings;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;
import org.eclipse.jdt.core.JavaCore;

import edu.wpi.ejutr.EjutrPlugin;
import edu.wpi.ejutr.file_operations.EJUTRFileWriter;
import edu.wpi.ejutr.logger.EJUTRTargetFileInfo;

public class RecordTestMethodWizard extends Wizard implements INewWizard {

	private RecordTestMethodWizardPage page1;
	
	private String conName  = null;
	private String objName = null;
	private String mehtodName = null;
	
	private ISelection selection; 
	
	
	public boolean performFinish() {
		conName  = page1.getContainerName();
		objName = page1.getObjectName();
		mehtodName = page1.getTestMethodName();
		
		try {
			doFinish(conName, objName, mehtodName);
		} catch (CoreException e) {
			e.printStackTrace();
		} 
		return true; 
	}

	private void doFinish(String containerName, String objName, String method) throws CoreException {
		
		IWorkspaceRoot root = ResourcesPlugin.getWorkspace().getRoot();
		IResource resource = root.findMember(new Path(containerName));
		if (!resource.exists() || !(resource instanceof IContainer)) {
			throwCoreException("Container \"" + containerName + "\" does not exist.");
		}
		IResource testCaseResource = root.findMember(new Path(containerName+"\\"+objName));
		IContainer container = (IContainer) resource;
		
		final IFile file = container.getFile(new Path(objName));
		//System.out.println(file.exists());
		//ICompilationUnit myCU = (ICompilationUnit) JavaCore.create(file);
		//IType[] types = myCU.getTypes();
		//types[0].createMethod("public void " + method + "() {} ",null,true,null);
		//System.out.println("Done saving info");
	}
	
	private void throwCoreException(String message) throws CoreException {
		IStatus status =
			new Status(IStatus.ERROR, "temp", IStatus.OK, message, null);
		throw new CoreException(status);
	}
	
	
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		this.selection = selection;
		

	}

	
	
	public void addPages() {
		page1 = new RecordTestMethodWizardPage(selection);
		addPage(page1);
	}

	public String getConName() {
		return conName;
	}

	public String getMehtodName() {
		return mehtodName;
	}

	public String getObjName() {
		return objName;
	}
	
}
